sheight = screen.height()
swidth= screen.width()
black = color.new(0,0,0)
white = color.new(255,255,255)
red = color.new(255,0,0)
green = color.new(0,255,0)
blue = color.new(0,0,255)
yellow = color.new(255,255,0)
magenta = color.new(255,0,255)
orange = color.new(255,200,0)
grey = color.new(100,100,100)
ballX = 200;
ballY = 200;
ballXVel = 0.707;
ballYVel = -0.707;
ballSpeed = 2;
ballRadius = 4;
batX = 180;
batY = 210;
batWidth = 40;
batHeight = 5;
batXVel = 0;
score = 0;
reset = false;
bonus = 1;
countdown=0;
headroom=42;
mainmenu=1;
sound=1;
paused=0;
easy=1;

n = nil;

wall   = { n,n,n,n,n,n,n,n,n,n,
		   n,n,n,n,n,n,n,n,n,n,
		   n,n,n,n,n,n,n,n,n,n,
		   n,n,n,n,n,n,n,n,n,n,
		   n,n,n,n,n,n,n,n,n,n };
		 
level1 = { n,n,n,n,n,n,n,n,n,n,
		   0,0,0,0,0,0,0,0,0,0,
		   1,1,1,n,n,n,n,1,1,1,
		   2,2,2,n,n,n,n,2,2,2,
		   3,3,3,n,n,n,n,3,3,3, };
		 
level2 = { 0,0,0,0,0,0,0,0,0,0,
		   1,1,n,n,1,1,n,n,1,1,
		   2,2,n,n,2,2,n,n,2,2,
		   3,3,n,n,3,3,n,n,3,3,
		   4,4,4,4,4,4,4,4,4,4 };

level3 = { n,n,n,n,0,0,n,n,n,n,
		   n,n,n,1,1,1,1,n,n,n,
		   n,n,2,2,2,2,2,2,n,n,
		   n,3,3,3,3,3,3,3,3,n,
		   4,4,4,4,4,4,4,4,4,4 }

level4 = { 5,n,n,5,n,n,5,5,5,n,
		   5,n,n,5,n,n,n,5,n,n,
		   5,5,5,5,n,n,n,5,n,n,
		   5,n,n,5,n,n,n,5,n,n,
		   5,n,n,5,n,n,5,5,5,n }

level5 = { n,n,n,n,0,0,n,n,n,n,
		   n,n,n,1,1,1,1,n,n,n,
		   n,n,2,2,2,2,2,2,n,n,
		   n,n,n,3,3,3,3,n,n,n,
		   n,n,n,n,4,4,n,n,n,n }
		   
level6 = { 0,0,0,0,0,0,0,0,0,0,
		   1,1,1,1,1,1,1,1,1,1,
		   2,2,9,9,2,2,9,9,2,2,
		   3,3,3,3,3,3,3,3,3,3,
		   4,4,4,4,4,4,4,4,4,4 };
		   
level7 = { 0,0,n,n,0,0,n,n,0,0,
		   1,1,n,n,1,1,n,n,1,1,
		   2,2,9,9,2,2,9,9,2,2,
		   3,3,n,n,3,3,n,n,3,3,
		   4,4,n,n,4,4,n,n,4,4 };
		   
level8 = { 0,n,0,n,0,n,0,n,0,n,
		   n,1,n,1,n,1,n,1,n,1,
		   2,n,2,n,2,n,2,n,2,n,
		   n,3,n,3,n,3,n,3,n,3,
		   4,n,4,n,4,n,4,n,4,n };
		   
level9 = { 0,0,n,n,0,0,n,n,0,0,
		   1,1,n,n,1,1,n,n,1,1,
		   2,2,2,2,2,2,2,2,2,2,
		   3,3,3,3,n,n,3,3,3,3,
		   4,4,4,4,n,n,4,4,4,4 };
		   
level10 = { 0,0,0,0,0,0,0,0,0,0,
 		    1,1,1,1,1,1,1,1,1,1,
		    5,5,5,5,5,5,5,5,5,5,
		    3,3,3,3,3,3,3,3,3,3,
		    5,5,5,5,5,5,5,5,5,5 };

levels = { level1, level2, level3, level4, level5, level6, level7, level8, level9, level10 }

soundOnOff = { x= 20, y=  5, w=160, h=30 }
gameMode =   { x=220, y=  5, w=160, h=30 }
accGame =    { x= 20, y=130, w=160, h=60 }
touchGame =  { x=220, y=130, w=160, h=60 }

buttons = { soundOnOff, gameMode, accGame, touchGame }
	
function resetGame()
    ballX = 200;
	ballY = 180;
 	reset = false;
	--random X velocity for ball (0.4 to 0.6)
	ballXVel = 0.4+(0.02*(math.random(11)-1))
	if (math.random(2) == 1) then
		ballXVel = -ballXVel
	end
	ballYVel = -math.sqrt(1-(ballXVel*ballXVel));
	bonus = 1;
	if (mainmenu == 0) then
		countdown=30;
	end
end

--move AI bat (during main menu)
function updateAIBat()
	batX = ballX - (batWidth / 2)
	if (batX < 0) then
		batX = 0
	elseif (batX > (swidth-batWidth)) then
		batX = swidth-batWidth;
	end
end

--move player's bat
function updatePlayerBat(x)
	vel = 0;
	if (x > 0.5) then
		vel = -5 * x;
		if (vel < -20) then
			vel = -20
		end
	elseif (x < -0.5) then
		vel = -5 * x;
		if (vel > 20) then
			vel = 20;
		end
	end
	batXVel = (0.8 * vel) + (0.2 * batXVel);
	batX = math.floor(batX + batXVel);
	if (batX < 0) then
		batX = 0
	elseif (batX > (swidth-batWidth)) then
		batX = swidth-batWidth;
	end
end

--move player's bat via touch interface
function updatePlayerBatByTouch(x,y)
	if (y > 150) then
		batX = x - (batWidth/2);
		if (batX < 0) then
		    batX = 0
		elseif (batX > (swidth-batWidth)) then
		    batX = swidth-batWidth;
		end
	end
end

function hitBrick(j)
	if (wall[j] == 9) then
		return;
	elseif (wall[j] == 5) then
		wall[j] = math.floor((j-1)/10);
		if (sound == 1) then
			audio.beep(415.305*math.pow(1.059463,5-wall[j]), 250);
		end
	else
		if (easy == 1) then
			score = score + (bonus*(5-wall[j]));
		else
			score = score + (bonus*(6-wall[j]));
		end
		if (sound == 1) then
			audio.beep(415.305*math.pow(1.059463,5-wall[j]), 250);
		end
		wall[j] = nil;
		bonus = bonus + 1;
	end
end
					
--update the ball position, check for impacts with the bat, screen edges or the wall
function updateBall()
	oldBallX = ballX;
	oldBallY = ballY;

	ballX = ballX + (ballXVel*ballSpeed);
	ballY = ballY + (ballYVel*ballSpeed);
	
	if (ballY < (headroom + 80)) then
		if (ballYVel < 0) then
			--check bottom edge of each accessible brick for collision
			for i = 0, 49 do
				--check a brick exists at this location and that it either on the bottom row or
				--there is no brick below it
				if (wall[i+1] ~= nil) and (((i + 10) > 49) or (wall[i+1+10] == nil)) then
					brickX1 = (i%10)*40;
					brickX2 = brickX1 + 40;
					brickY1 = headroom+math.floor(i/10)*12;
					brickY2 = brickY1 + 12;
					if ((ballY > (brickY2 - ballRadius)) and (ballY < (brickY2 + ballRadius)) and (oldBallY > (brickY2 + ballRadius)) and
						(ballX > (brickX1 - ballRadius)) and (ballX < (brickX2 + ballRadius))) then
						ballY = 2*(brickY2+ballRadius)-ballY;
						ballYVel = -ballYVel;
						hitBrick(i+1);
						return;
					end
				end
			end
		end
	
		if (ballYVel > 0) then
			--check top edge of each accessible brick for collision
			for i = 0, 49 do
				--check a brick exists at this location and that it either on the top row or
				--there is no brick above it
				if (wall[i+1] ~= nil) and ((i < 10) or (wall[i+1-10] == nil)) then
					brickX1 = (i%10)*40;
					brickX2 = brickX1 + 40;
					brickY1 = headroom+math.floor(i/10)*12;
					brickY2 = brickY1 + 12;
					if ((ballY > (brickY1 - ballRadius)) and (ballY < (brickY1 + ballRadius)) and (oldBallY < (brickY1 - ballRadius)) and
						(ballX > (brickX1 - ballRadius)) and (ballX < (brickX2 + ballRadius))) then
						ballY = 2*(brickY1-ballRadius)-ballY;
						ballYVel = -ballYVel;
						hitBrick(i+1);
						return;
					end
				end
			end
		end
	
		if (ballXVel < 0) then
			--check right edge of each accessible brick for collision
			for i = 0, 49 do
				--check a brick exists at this location, it is not on the right hand edge, and that there is no brick to the right of it
				if (wall[i+1] ~= nil) and ((i+1)%10 ~= 0) and (wall[i+1+1] == nil) then
					brickX1 = (i%10)*40;
					brickX2 = brickX1 + 40;
					brickY1 = headroom+math.floor(i/10)*12;
					brickY2 = brickY1 + 12;
					if ((ballY > (brickY1 - ballRadius)) and (ballY < (brickY2 + ballRadius)) and
						(ballX > (brickX2 - ballRadius)) and (ballX < (brickX2 + ballRadius))) then
						ballX = 2*(brickX2+ballRadius)-ballX;
						ballXVel = -ballXVel;
						hitBrick(i+1);
						return;
					end
				end
			end
		end
	
		if (ballXVel > 0) then
			--check left edge of each accessible brick for collision
			for i = 0, 49 do
				--check a brick exists at this location, it is not on the left hand edge, and that there is no brick to the left of it
				if (wall[i+1] ~= nil) and (i%10 ~= 0) and (wall[i+1-1] == nil) then
					brickX1 = (i%10)*40;
					brickX2 = brickX1 + 40;
					brickY1 = headroom+math.floor(i/10)*12;
					brickY2 = brickY1 + 12;
					if ((ballY > (brickY1 - ballRadius)) and (ballY < (brickY2 + ballRadius)) and
						(ballX > (brickX1 - ballRadius)) and (ballX < (brickX1 + ballRadius))) then
						ballX = 2*(brickX1-ballRadius)-ballX;
						ballXVel = -ballXVel;
						hitBrick(i+1);
						return;
					end
				end
			end
		end
	end
	
	--check for a collision with top of bat
	if (oldBallY < batY) and (ballYVel > 0) then
		if (ballY > (batY - ballRadius)) and (ballY < (batY + ballRadius)) then
			--compute collision point
			impactBallY = batY - ballRadius;
			--compute proportion of Y axis movement to get to impactBallY
			frac = (impactBallY - oldBallY) / (ballY - oldBallY);
			--used that to compute the X axix impact point
			impactBallX = oldBallX + (ballXVel*ballSpeed*frac);
			
			--did we actually hit the bat?
			if ((impactBallX > (batX - ballRadius)) and (impactBallX < (batX + batWidth + ballRadius))) then
				bonus = 1;
				--Depending upon location of the hit, vary the angle of reflection
				if (impactBallX < (batX + 0.1*batWidth)) then
					if (ballXVel > 0) then
						ballXVel = -ballXVel;
					else
						ballXVel = 1.5*ballXVel;
					end
				elseif (impactBallX < (batX + 0.35*batWidth)) then
					if (ballXVel > 0) then
						ballXVel = 0.7*ballXVel;
					else
						ballXVel = 1.2*ballXVel;
					end
				elseif (impactBallX > (batX + 0.9*batWidth)) then
					if (ballXVel > 0) then
						ballXVel = 1.5*ballXVel;
					else
						ballXVel = -ballXVel;
					end
				elseif (impactBallX > (batX + 0.65*batWidth)) then
					if (ballXVel > 0) then
						ballXVel = 1.2*ballXVel;
					else
						ballXVel = 0.7*ballXVel;
					end
				end
				--prevent angles getting too extreme
				if (ballXVel < -0.8) then
					ballXVel = -0.8
				elseif (ballXVel > -0.2) and (ballXVel < 0) then
					ballXVel = -0.2
				elseif (ballXVel > 0) and (ballXVel < 0.2) then
					ballXVel = 0.2
				elseif (ballXVel > 0.8) then
					ballXVel = 0.8
				end
				--maintain constant velocity
				ballYVel = -math.sqrt(1-(ballXVel*ballXVel));
				--compute new ball position (impact position + new velocity * (1-frac)
				ballX = impactBallX + (ballXVel*ballSpeed*(1-frac));
				ballY = impactBallY + (ballYVel*ballSpeed*(1-frac));
				return;
			end
		end
	end

	--check for left and right screen edges
	if (ballX < ballRadius) then
		ballX = (2*ballRadius)-ballX;
		ballXVel = -ballXVel;
	elseif (ballX > (swidth-ballRadius)) then
		ballX = (2*(swidth-ballRadius)-ballX);
		ballXVel = -ballXVel;
	end
	
	--check for top and bottom screen edges (bottom edge == lose a life!)
	if (ballY < ballRadius) then
	    ballY = (2*ballRadius)-ballY;
	    ballYVel = -ballYVel;
	elseif (ballY > (sheight-ballRadius)) then
		reset = true;
	end
end
   
function drawScreen()
   	screen.fillrect(0,0,swidth,sheight,black);
	if (mainmenu == 0) then
		text.draw(4,4," "..score,"left",200);
		text.draw(150,4," "..bonus.."x","center",250);
		text.draw(330,4," "..lives,"right");
	end
	for i = 0, 49 do
		clr = nil;
		if (wall[i+1] == 0) then clr = red;
		elseif (wall[i+1] == 1) then clr = green;
		elseif (wall[i+1] == 2) then clr = blue;
		elseif (wall[i+1] == 3) then clr = yellow;
		elseif (wall[i+1] == 4) then clr = magenta;
		elseif (wall[i+1] == 5) then clr = orange;
		elseif (wall[i+1] == 9) then clr = grey;
		end
		if (clr ~= nil) then
			screen.fillrect((i%10)*40, headroom+(math.floor(i/10)*12), 40, 12, clr);
		end
	end
   	screen.fillrect(batX,batY,batWidth,batHeight,white);
	if (countdown > 0) and (paused==0) then
		ots = text.size(16 + (math.ceil(countdown/10) * 10) - countdown);
		text.draw(150,150,""..math.ceil(countdown/10),"center",250);
		countdown = countdown - 1;
		text.size(ots);
	end
	bX = math.floor(ballX);
	bY = math.floor(ballY);
	screen.drawline(bX-2, bY-3, bX+1, bY-3, white);
	screen.drawline(bX-3, bY-2, bX+2, bY-2, white);
	screen.drawline(bX-4, bY-1, bX+3, bY-1, white);
	screen.drawline(bX-4, bY  , bX+3, bY  , white);
	screen.drawline(bX-3, bY+1, bX+2, bY+1, white);
	screen.drawline(bX-2, bY+2, bX+1, bY+2, white);
	if (mainmenu == 1) then
		drawRectOutline(20,5,160,30,grey,2);
		drawRectOutline(220,5,160,30,grey,2);
		drawRectOutline(20,130,160,60,grey,2);
		drawRectOutline(220,130,160,60,grey,2);
		otc = text.color(white);
		ots = text.size(18);
		if (sound == 1) then
			text.draw(20,10,": ", "center", 180);
		else
			text.draw(20,10,": ", "center", 180);
		end
		if (easy == 1) then
			text.draw(220,10," ", "center", 380);
		else
			text.draw(220,10," ", "center", 380);
		end
		text.draw(0,140," ","center",200);
		text.draw(0,160,"","center",200);
		text.draw(200,140," ","center",400);
		text.draw(200,160,"","center",400);
		text.size(12);
		text.draw(5,225," 1.0 - by DanTheLegoMan","left",400);
		text.color(otc);
		text.size(ots);
	end
	if (paused == 1) then
		drawRectOutline(150,150,100,30,grey,2);
		text.draw(150,155,"","center",250);
	end
	screen.update()
end

function drawRectOutline(x,y,w,h,clr,thick)
	for i = 0, thick do
		screen.drawline(x,y+i,x+w,y+i,clr);
		screen.drawline(x+w-i,y,x+w-i,y+h,clr);
		screen.drawline(x+w,y+h-i,x,y+h-i,clr);
		screen.drawline(x+i,y+h,x+i,y,clr);
	end
end

function endLevelCheck()
	bricks = false;
	for i = 0, 49 do
		if (wall[i+1] ~= nil) and (wall[i+1] ~= 9) then
			bricks = true;
			break;
		end
	end
	
	if (bricks == false) then
		if (level < numLevels) then
			level = level + 1;
		else
			level = 1;
			if (headroom <= 66) then
				headroom = headroom + 12;
			end
		end
		if (lives ~= 0) then
			if (easy == 1) and ((level%2)==1) then
				lives = lives + 1;
			elseif (easy == 0) then
				lives = lives + 1;
			end
		end
		for i = 1, 50 do
			wall[i] = levels[level][i];
		end
		resetGame();
	end
end

function showGameOver()
	screen.fillrect(0,0,swidth,sheight,black);
	ots = text.size(50);
	otc = text.color(red);
	text.draw(0,90," ","center",swidth);
	text.size(ots);
	text.color(otc);
	screen.update();
	os.sleep(100);
end

function doMainMenu()
	math.random();
	level = math.random(10)
	for i = 1, 50 do
		wall[i] = levels[level][i];
	end
	mainmenu = 1;
	lives = 0;
	batX = 180;
	batY = 210;
	batWidth = 40;
	headroom=42;
	x = 0;
	y = 0;
	resetGame();
	ballSpeed = 8;
	
	--AI Player loop and checking for user buttons
	while 1 do 
		if control.read()==1 then
			if (control.isTouch() == 1) and (touch.click() == 1) then
				x, y = touch.pos()
				for i = 1, 4 do
					if (x > buttons[i].x) and (x < buttons[i].x + buttons[i].w) and (y > buttons[i].y) and (y < (buttons[i].y + buttons[i].h)) then
						if (i == 1) then
							sound = (sound + 1) % 2
							break;
						elseif (i == 2) then
							easy = (easy + 1) % 2
							break;
						elseif (i == 3) then
							return 1; -- Accelerometer Game
						else
							return 2; -- Touch Game
						end
					end
				end
			elseif (control.isButton()==1) and (button.click() == 1) then
				return 0;
			end
		end

		--move bat
		updateAIBat();
		--move ball
		updateBall();
		--check for miss
		if (reset) then
			resetGame();
		end
		--check if all the bricks have been cleared
		endLevelCheck();
		drawScreen();
		screen.backlight(100);
		os.sleep(1);
	end
	
	return 0;
end

-- Touch game has bat a little higher to make room for touch control, wall is also higher, and ball velocity is faster
function doTouchGame()
	lives = 5;
	level = 1;
	for i = 1, 50 do
		wall[i] = levels[level][i];
	end
	mainmenu = 0;
	batX = 180;
	batY = 190;
	if (easy == 1) then
		batWidth = 40;
		ballSpeed = 7;
	else
		batWidth = 30;
		ballSpeed = 8;
	end
	headroom=30;
	score = 0;
	resetGame();
	quit = false;
	
	--game loop
	while 1 do 
		--check for input
		for i=0,9 do
			if control.read()==1 then
				if control.isTouch()==1 then
					x,y = touch.pos()
					if (paused==0) and (touch.move() == 1) then
						updatePlayerBatByTouch(x,y);
					elseif (touch.click() == 1) then
						if (paused == 0) then
							--if touched the top half of the screen, pause the game
							if (y < 120) then paused = 1 end
						else
							--touch anywhere to unpause/resume (after countdown)
							paused = 0;
							countdown = 30;
						end
					end
				elseif control.isButton()==1 then
					if button.click() == 1 then
						paused = 0;
						countdown = 0;
						quit = true;
						break
					end
				end
			end
		end
		if (quit) then
			break;
		end
		
		if (countdown == 0) and (paused == 0) then
			--move ball
			updateBall();
			--check for miss
			if (reset) then
				lives = lives - 1;
				if (lives <= 0) then
					showGameOver();
					break;
				end
				resetGame();
			end
			--check if all the bricks have been cleared
			endLevelCheck();
			screen.backlight(100);
		end
		drawScreen();
		os.sleep(1);
	end
end

function doAccGame()
	lives = 5;
	level = 1;
	for i = 1, 50 do
		wall[i] = levels[level][i];
	end
	accelerometer.open()
	os.sleep(10);
	if (accelerometer.set_datatype) then
		accelerometer.set_datatype("all")
	else
		accelerometer.set_senddatatype("all")
	end
	accelerometer.set_samplerate(100)
	lastLPF_x_dir=0
	factor = 0.6;
	mainmenu = 0;
	batX = 180;
	batY = 210;
	if (easy == 1) then
		batWidth = 50;
		ballSpeed = 6;
	else
		batWidth = 40;
		ballSpeed = 7;
	end
	headroom=42;
	score = 0;
	resetGame();
	quit = false;
	
	--game loop
	while 1 do 
		--check for input
		for i=0,2 do
			if control.read()==1 then
				if control.isSensor() == 1 then
					x_dir,y_dir,z_dir = accelerometer.getdata("xyz")
					--Simple low-pass filter
					lastLPF_x_dir = (x_dir * factor) + (lastLPF_x_dir * (1.0 - factor));
				elseif control.isTouch()==1 then
					x,y = touch.pos()
					if (touch.click() == 1) then
						if (paused == 0) then
							--if touched the top half of the screen, pause the game
							if (y < 120) then paused = 1 end
						else
							--touch anywhere to unpause/resume (after countdown)
							paused = 0;
							countdown = 30;
						end
					end
				elseif control.isButton()==1 then
					if button.click() == 1 then
						paused = 0;
						countdown = 0;
						quit = true;
						break
					end
				end
			end
		end
		if (quit) then
			break;
		end
		
		if (paused == 0) then
			--move bat
			updatePlayerBat(lastLPF_x_dir);
			if (countdown == 0) then
				--move ball
				updateBall();
				--check for miss
				if (reset) then
					lives = lives - 1;
					if (lives <= 0) then
						showGameOver();
						break;
					end
					resetGame();
				end
				--check if all the bricks have been cleared
				endLevelCheck();
				screen.backlight(100);
			end
		end
		drawScreen();
		os.sleep(1);
	end
	accelerometer.close()
end


--initialization
oldsize = text.size(16);
oldcolor = text.color(white);
numLevels = 10;
t = os.date('*t')
math.randomseed(os.time(t));

while (1) do
	game = doMainMenu()
	if (game == 0) then
		break;
	elseif (game == 1) then
		doAccGame();
	elseif( game == 2) then
		doTouchGame();
	end
end

text.size(oldsize);
text.color(oldcolor);
